summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorRobin H. Johnson <robbat2@gentoo.org>2015-08-08 13:49:04 -0700
committerRobin H. Johnson <robbat2@gentoo.org>2015-08-08 17:38:18 -0700
commit56bd759df1d0c750a065b8c845e93d5dfa6b549d (patch)
tree3f91093cdb475e565ae857f1c5a7fd339e2d781e /sys-devel/binutils-config
downloadgentoo-56bd759df1d0c750a065b8c845e93d5dfa6b549d.tar.gz
gentoo-56bd759df1d0c750a065b8c845e93d5dfa6b549d.tar.bz2
gentoo-56bd759df1d0c750a065b8c845e93d5dfa6b549d.zip
proj/gentoo: Initial commit
This commit represents a new era for Gentoo: Storing the gentoo-x86 tree in Git, as converted from CVS. This commit is the start of the NEW history. Any historical data is intended to be grafted onto this point. Creation process: 1. Take final CVS checkout snapshot 2. Remove ALL ChangeLog* files 3. Transform all Manifests to thin 4. Remove empty Manifests 5. Convert all stale $Header$/$Id$ CVS keywords to non-expanded Git $Id$ 5.1. Do not touch files with -kb/-ko keyword flags. Signed-off-by: Robin H. Johnson <robbat2@gentoo.org> X-Thanks: Alec Warner <antarus@gentoo.org> - did the GSoC 2006 migration tests X-Thanks: Robin H. Johnson <robbat2@gentoo.org> - infra guy, herding this project X-Thanks: Nguyen Thai Ngoc Duy <pclouds@gentoo.org> - Former Gentoo developer, wrote Git features for the migration X-Thanks: Brian Harring <ferringb@gentoo.org> - wrote much python to improve cvs2svn X-Thanks: Rich Freeman <rich0@gentoo.org> - validation scripts X-Thanks: Patrick Lauer <patrick@gentoo.org> - Gentoo dev, running new 2014 work in migration X-Thanks: Michał Górny <mgorny@gentoo.org> - scripts, QA, nagging X-Thanks: All of other Gentoo developers - many ideas and lots of paint on the bikeshed
Diffstat (limited to 'sys-devel/binutils-config')
-rw-r--r--sys-devel/binutils-config/binutils-config-1.9-r4.ebuild19
-rw-r--r--sys-devel/binutils-config/binutils-config-2-r1.ebuild19
-rw-r--r--sys-devel/binutils-config/binutils-config-3-r3.ebuild19
-rw-r--r--sys-devel/binutils-config/binutils-config-4-r1.ebuild24
-rw-r--r--sys-devel/binutils-config/binutils-config-4-r2.ebuild24
-rw-r--r--sys-devel/binutils-config/binutils-config-4-r3.ebuild24
-rwxr-xr-xsys-devel/binutils-config/files/binutils-config-1.9410
-rwxr-xr-xsys-devel/binutils-config/files/binutils-config-2434
-rwxr-xr-xsys-devel/binutils-config/files/binutils-config-3509
-rwxr-xr-xsys-devel/binutils-config/files/binutils-config-4465
-rw-r--r--sys-devel/binutils-config/files/binutils-config.877
-rw-r--r--sys-devel/binutils-config/metadata.xml5
12 files changed, 2029 insertions, 0 deletions
diff --git a/sys-devel/binutils-config/binutils-config-1.9-r4.ebuild b/sys-devel/binutils-config/binutils-config-1.9-r4.ebuild
new file mode 100644
index 00000000000..ee750bdffb6
--- /dev/null
+++ b/sys-devel/binutils-config/binutils-config-1.9-r4.ebuild
@@ -0,0 +1,19 @@
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+DESCRIPTION="Utility to change the binutils version being used"
+HOMEPAGE="http://www.gentoo.org/"
+SRC_URI=""
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="alpha amd64 arm hppa ia64 m68k ~mips ppc ppc64 s390 sh sparc x86 ~sparc-fbsd ~x86-fbsd"
+IUSE=""
+
+RDEPEND="userland_GNU? ( >=sys-apps/findutils-4.2 )"
+
+src_install() {
+ newbin "${FILESDIR}"/${PN}-${PV} ${PN} || die
+ doman "${FILESDIR}"/${PN}.8
+}
diff --git a/sys-devel/binutils-config/binutils-config-2-r1.ebuild b/sys-devel/binutils-config/binutils-config-2-r1.ebuild
new file mode 100644
index 00000000000..ee750bdffb6
--- /dev/null
+++ b/sys-devel/binutils-config/binutils-config-2-r1.ebuild
@@ -0,0 +1,19 @@
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+DESCRIPTION="Utility to change the binutils version being used"
+HOMEPAGE="http://www.gentoo.org/"
+SRC_URI=""
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="alpha amd64 arm hppa ia64 m68k ~mips ppc ppc64 s390 sh sparc x86 ~sparc-fbsd ~x86-fbsd"
+IUSE=""
+
+RDEPEND="userland_GNU? ( >=sys-apps/findutils-4.2 )"
+
+src_install() {
+ newbin "${FILESDIR}"/${PN}-${PV} ${PN} || die
+ doman "${FILESDIR}"/${PN}.8
+}
diff --git a/sys-devel/binutils-config/binutils-config-3-r3.ebuild b/sys-devel/binutils-config/binutils-config-3-r3.ebuild
new file mode 100644
index 00000000000..7b52c186da8
--- /dev/null
+++ b/sys-devel/binutils-config/binutils-config-3-r3.ebuild
@@ -0,0 +1,19 @@
+# Copyright 1999-2014 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+DESCRIPTION="Utility to change the binutils version being used"
+HOMEPAGE="http://www.gentoo.org/"
+SRC_URI=""
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="alpha amd64 arm arm64 hppa ia64 m68k ~mips ppc ppc64 s390 sh sparc x86 ~amd64-fbsd ~sparc-fbsd ~x86-fbsd"
+IUSE=""
+
+RDEPEND="userland_GNU? ( !<sys-apps/findutils-4.2 )"
+
+src_install() {
+ newbin "${FILESDIR}"/${PN}-${PV} ${PN} || die
+ doman "${FILESDIR}"/${PN}.8
+}
diff --git a/sys-devel/binutils-config/binutils-config-4-r1.ebuild b/sys-devel/binutils-config/binutils-config-4-r1.ebuild
new file mode 100644
index 00000000000..2bf97f349b3
--- /dev/null
+++ b/sys-devel/binutils-config/binutils-config-4-r1.ebuild
@@ -0,0 +1,24 @@
+# Copyright 1999-2014 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI="4"
+
+DESCRIPTION="Utility to change the binutils version being used"
+HOMEPAGE="http://www.gentoo.org/"
+SRC_URI=""
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86 ~amd64-fbsd ~sparc-fbsd ~x86-fbsd"
+IUSE=""
+
+# We also RDEPEND on sys-apps/findutils which is in base @system
+RDEPEND="sys-apps/gentoo-functions"
+
+S=${WORKDIR}
+
+src_install() {
+ newbin "${FILESDIR}"/${PN}-${PV} ${PN}
+ doman "${FILESDIR}"/${PN}.8
+}
diff --git a/sys-devel/binutils-config/binutils-config-4-r2.ebuild b/sys-devel/binutils-config/binutils-config-4-r2.ebuild
new file mode 100644
index 00000000000..6adeaa037a7
--- /dev/null
+++ b/sys-devel/binutils-config/binutils-config-4-r2.ebuild
@@ -0,0 +1,24 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI="4"
+
+DESCRIPTION="Utility to change the binutils version being used"
+HOMEPAGE="http://www.gentoo.org/"
+SRC_URI=""
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="alpha amd64 arm arm64 hppa ia64 m68k ~mips ppc ppc64 s390 sh sparc x86 ~amd64-fbsd ~sparc-fbsd ~x86-fbsd"
+IUSE=""
+
+# We also RDEPEND on sys-apps/findutils which is in base @system
+RDEPEND="sys-apps/gentoo-functions"
+
+S=${WORKDIR}
+
+src_install() {
+ newbin "${FILESDIR}"/${PN}-${PV} ${PN}
+ doman "${FILESDIR}"/${PN}.8
+}
diff --git a/sys-devel/binutils-config/binutils-config-4-r3.ebuild b/sys-devel/binutils-config/binutils-config-4-r3.ebuild
new file mode 100644
index 00000000000..53956f13904
--- /dev/null
+++ b/sys-devel/binutils-config/binutils-config-4-r3.ebuild
@@ -0,0 +1,24 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI="4"
+
+DESCRIPTION="Utility to change the binutils version being used"
+HOMEPAGE="http://www.gentoo.org/"
+SRC_URI=""
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86 ~amd64-fbsd ~sparc-fbsd ~x86-fbsd"
+IUSE=""
+
+# We also RDEPEND on sys-apps/findutils which is in base @system
+RDEPEND="sys-apps/gentoo-functions"
+
+S=${WORKDIR}
+
+src_install() {
+ newbin "${FILESDIR}"/${PN}-${PV} ${PN}
+ doman "${FILESDIR}"/${PN}.8
+}
diff --git a/sys-devel/binutils-config/files/binutils-config-1.9 b/sys-devel/binutils-config/files/binutils-config-1.9
new file mode 100755
index 00000000000..8a371d44ce3
--- /dev/null
+++ b/sys-devel/binutils-config/files/binutils-config-1.9
@@ -0,0 +1,410 @@
+#!/bin/bash
+# Copyright 1999-2007 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+# Format of /etc/env.d/binutils/:
+# config-TARGET: CURRENT=version for TARGET
+# TARGET-VER: has a TARGET and VER variable
+
+[[ -z ${ROOT} ]] && ROOT="/"
+[[ ${ROOT} != */ ]] && ROOT="${ROOT}/"
+[[ ${ROOT} != /* ]] && ROOT="${PWD}${ROOT}"
+
+cd /
+
+trap ":" INT QUIT TSTP
+
+argv0=${0##*/}
+source /etc/init.d/functions.sh || {
+ echo "${argv0}: Could not source /etc/init.d/functions.sh!" 1>&2
+ exit 1
+}
+esyslog() { :; }
+umask 022
+
+usage() {
+cat << USAGE_END
+
+Usage: ${HILITE}binutils-config${NORMAL} ${GOOD}[options]${NORMAL} ${BRACKET}[binutils profile]${NORMAL}
+
+${HILITE}General Options:${NORMAL}
+ ${GOOD}-c, --get-current-profile${NORMAL} Print current profile
+ ${GOOD}-l, --list-profiles${NORMAL} Print a list of available profiles
+ ${GOOD}-u, --uninstall${NORMAL} Remove all signs of specified target
+ ${GOOD}-d, --debug${NORMAL} Execute with debug output
+
+${HILITE}Arch Specific Cruft:${NORMAL}
+ ${GOOD}--amd64${NORMAL} Install extra amd64 links (x86_64)
+ ${GOOD}--arm${NORMAL} Install extra arm links (arm/armeb)
+ ${GOOD}--mips${NORMAL} Install extra mips links (mips/mipsel)
+ ${GOOD}--x86${NORMAL} Install extra x86 links (i[3-6]86)
+
+Profile names are of the form: ${BRACKET}<CTARGET>-<binutils version>${NORMAL}
+For example: ${BRACKET}i686-pc-linux-gnu-2.15.92.0.2${NORMAL}
+
+For more info, please see ${HILITE}binutils-config${NORMAL}(8).
+USAGE_END
+}
+
+switch_profile() {
+ unset TARGET VER LIBPATH FAKE_TARGETS
+ source "${ENV_D}/${PROFILE}"
+ if [[ -z ${TARGET} ]] ; then
+ eerror "${PROFILE} is invalid (no \$TARGET defined) :("
+ return 1
+ fi
+ if [[ -z ${VER} ]] ; then
+ eerror "${PROFILE} is invalid (no \$VER defined) :("
+ return 1
+ fi
+
+ #
+ # Older installs don't have 'FAKE_TARGETS' defined, so lets
+ # update these env.d entries so that we don't force the poor
+ # user to re-emerge their binutils just for 1 envvar :/
+ #
+ if [[ ${FAKE_TARGETS-poor user} == "poor user" ]] ; then
+ local targ=${TARGET/-*}
+ local FAKE_TARGETS=${TARGET}
+ case ${targ} in
+ mips|powerpc|sparc)
+ FAKE_TARGETS="${FAKE_TARGETS} ${TARGET/-/64-}";;
+ mips64|powerpc64|sparc64)
+ FAKE_TARGETS="${FAKE_TARGETS} ${TARGET/64-/-}";;
+ esac
+ echo "FAKE_TARGETS=\"${FAKE_TARGETS}\"" >> "${ENV_D}/${PROFILE}"
+ fi
+ local fake_targ_append="${TARGET#*-}"
+ FAKE_TARGETS="${FAKE_TARGETS} ${FAKE_TARGETS_USER// /-${fake_targ_append} }"
+
+ ebegin "Switching to ${PROFILE}"
+
+ #
+ # Generate binary symlinks
+ # On systems that do 32bit/64bit, we need to fake an
+ # extra set of binary names (${FAKE_TARGETS})
+ #
+ BINPATH=""
+ BINPATH_LINKS=""
+ if [[ ${TARGET} != ${HOST} ]] ; then
+ #
+ # Newer paths: /usr/${HOST}/${TARGET}/...
+ # Older paths: /usr/${TARGET}/...
+ #
+ if [[ -d ${ROOT}/usr/${HOST}/${TARGET}/binutils-bin/${VER} ]] ; then
+ BINPATH=/usr/${HOST}/${TARGET}/binutils-bin/${VER}
+ BINPATH_LINKS=/usr/libexec/gcc/${TARGET}
+ fi
+ fi
+ if [[ -z ${BINPATH} ]] ; then
+ BINPATH=/usr/${TARGET}/binutils-bin/${VER}
+ BINPATH_LINKS=/usr/${TARGET}/bin
+ fi
+ cd "${ROOT}/${BINPATH}" || exit 1
+ mkdir -p "${ROOT}/${BINPATH_LINKS}" "${ROOT}/usr/bin"
+ for x in * ; do
+ ln -sf "${BINPATH}/${x}" "${ROOT}/${BINPATH_LINKS}/${x}"
+ ln -sf "${BINPATH_LINKS}/${x}" "${ROOT}"/usr/bin/${TARGET}-${x}
+ for fake in ${FAKE_TARGETS} ; do
+ [[ -f ${ENV_D}/config-${fake} ]] && continue
+ ln -sf "${BINPATH_LINKS}/${x}" "${ROOT}"/usr/bin/${fake}-${x}
+ done
+ if [[ ${TARGET} == ${HOST} ]] ; then
+ ln -sf ${TARGET}-${x} "${ROOT}"/usr/bin/${x}
+ fi
+ done
+
+ #
+ # Generate library / ldscripts symlinks
+ #
+ LIBPATH=${LIBPATH:-/usr/lib/binutils/${TARGET}/${VER}}
+ cd "${ROOT}/${LIBPATH}" || exit 1
+ if [[ ${TARGET} == ${HOST} ]] ; then
+ dstlib=${ROOT}/usr/${HOST}/lib
+ else
+ dstlib=${ROOT}/usr/${HOST}/${TARGET}/lib
+ # Clean out old path
+ rm -rf "${ROOT}"/usr/${TARGET}/lib/ldscripts
+ rmdir "${ROOT}"/usr/${TARGET}/lib >& /dev/null
+ fi
+ # When upgrading, we need to clean up ldscripts and libs
+ rm -rf "${dstlib}/ldscripts" "${ROOT}/${BINPATH_LINKS}"/ldscripts
+ mkdir -p "${dstlib}"
+ ln -sf "${LIBPATH}/ldscripts" "${dstlib}"/ldscripts
+ find -L "${dstlib}" -type l -exec rm {} \;
+ for x in lib* ; do
+ ln -sf "${LIBPATH}/${x}" "${dstlib}/${x}"
+ done
+
+ #
+ # Generate include symlinks
+ #
+ INCPATH=${LIBPATH}/include
+ if [[ -d ${ROOT}/${INCPATH} ]] ; then
+ cd "${ROOT}/${INCPATH}" || exit 1
+ if [[ ${HOST} == ${TARGET} ]] ; then
+ mkdir -p "${ROOT}/usr/include"
+ for x in * ; do
+ ln -sf "${INCPATH}/${x}" "${ROOT}/usr/include/${x}"
+ done
+ else
+ # Clean out old path
+ find . -type f -exec rm -f "${ROOT}/usr/${TARGET}/usr/include/{}" \;
+ rmdir "${ROOT}/usr/${TARGET}/usr/include" >& /dev/null
+ rmdir "${ROOT}/usr/${TARGET}/usr" >& /dev/null
+ rmdir "${ROOT}/usr/${TARGET}" >& /dev/null
+ fi
+ fi
+
+ #
+ # Make sure proper paths get updated
+ #
+ if [[ ${TARGET} == ${HOST} ]] ; then
+ DATAPATH=/usr/share/binutils-data/${TARGET}/${VER}
+ [[ -d ${DATAPATH}/man ]] && \
+ echo "MANPATH=${DATAPATH}/man" > "${ROOT}"/etc/env.d/05binutils
+ [[ -d ${DATAPATH}/info ]] && \
+ echo "INFOPATH=${DATAPATH}/info" >> "${ROOT}"/etc/env.d/05binutils
+ # hmm, `ld` has this in SEARCH_DIR(), but ld.so does not ...
+ echo "LDPATH=/usr/${TARGET}/lib" >> "${ROOT}"/etc/env.d/05binutils
+ fi
+
+ eend 0
+
+ echo "CURRENT=${VER}" > "${ENV_D}/config-${TARGET}"
+
+ #
+ # Regen env.d if need/can be
+ #
+ if [[ ${ROOT} == "/" ]] && [[ ${TARGET} == ${HOST} ]] ; then
+ env-update
+ echo
+ ewarn "Please remember to run:"
+ echo
+ ewarn " # source /etc/profile"
+ echo
+ fi
+
+ return 0
+}
+
+uninstall_target() {
+ if [[ ${TARGET} == ${HOST} ]] ; then
+ eerror "${argv0}: Refusing to uninstall native binutils"
+ exit 1
+ fi
+
+ shopt -s nullglob
+ PROFILE=""
+
+ for PROFILE in "${ENV_D}"/${TARGET}-* ; do
+ ewarn "Removing all signs of ${PROFILE##*/}"
+ rm -f "${ENV_D}"/${PROFILE}
+ done
+ if [[ -z ${PROFILE} ]] && [[ ! -e ${ENV_D}/config-${TARGET} ]] ; then
+ eerror "${argv0}: No profiles exist for '${TARGET}'"
+ exit 1
+ fi
+
+ rm -f "${ENV_D}"/config-${TARGET}
+
+ # XXX: we still leave behind FAKE_TARGETS in /usr/bin ...
+ for x in addr2line ar as c++filt elf2flt flthdr gprof ld ld.real \
+ nm objcopy objdump ranlib readelf size strings strip ; do
+ rm -f "${ROOT}"/usr/bin/${TARGET}-${x}
+ rm -f "${ROOT}"/usr/{${HOST}/,}${TARGET}/bin/${x}
+ rm -f "${ROOT}"/usr/libexec/gcc/${TARGET}/${x}
+ done
+ for x in ansidecl.h bfd.h bfdlink.h dis-asm.h symcat.h ; do
+ rm -f "${ROOT}"/usr/{${HOST}/,}${TARGET}/{usr/,}include/${x}
+ done
+ for x in bfd iberty opcodes ; do
+ rm -f "${ROOT}"/usr/${HOST}/${TARGET}/lib/lib${x}{{-*,}.so,.a,.la}
+ done
+ # Delete broken symlinks
+ local destdir="${ROOT}/usr/${HOST}/${TARGET}"
+ rm -f "${destdir}"/lib/ldscripts
+ find -L "${destdir}"/lib -type l -exec rm {} \;
+ rmdir "${destdir}"/lib "${destdir}" 2>/dev/null
+ rmdir "${destdir}"/{bin,include,lib,usr} "${destdir}" 2>/dev/null
+ rmdir "${ROOT}"/var/db/pkg/cross-${TARGET} 2>/dev/null
+
+ rm -f "${ENV_D}"/${TARGET}-*
+}
+
+get_current_profile() {
+ if [[ ! -f ${ENV_D}/config-${PROFILE} ]] ; then
+ eerror "${argv0}: No binutils profile is active!"
+ return 1
+ fi
+
+ source "${ENV_D}/config-${PROFILE}"
+
+ if [[ -z ${CURRENT} ]] ; then
+ eerror "${argv0}: No binutils profile is active!"
+ return 1
+ fi
+
+ echo "${PROFILE}-${CURRENT}"
+
+ return 0
+}
+
+list_profiles() {
+ local i=1
+
+ set_HOST
+
+ if [[ ${ROOT} != / ]] ; then
+ echo "Using binutils-config info in ${ROOT}"
+ fi
+ target=
+ for x in "${ENV_D}"/* ; do
+ if [[ -f ${x} ]] && [[ ${x/\/config-} == ${x} ]] ; then
+ source "${x}"
+ if [[ ${target} != ${TARGET} ]] ; then
+ [[ -n ${target} ]] && echo
+ target=${TARGET}
+ fi
+
+ x=${x##*/}
+ if [[ -e ${ENV_D}/config-${TARGET} ]] ; then
+ source "${ENV_D}/config-${TARGET}"
+ if [[ ${VER} == ${CURRENT} ]] ; then
+ [[ ${TARGET} == ${HOST} ]] \
+ && x="${x} ${GOOD}*${NORMAL}" \
+ || x="${x} ${HILITE}*${NORMAL}"
+ fi
+ fi
+ echo " [${i}] ${x}"
+ ((++i))
+ fi
+ done
+}
+
+set_HOST() {
+ [[ -n ${HOST} ]] && return 0
+
+ if [[ -z ${CHOST} ]] ; then
+ HOST=$(portageq envvar CHOST)
+ else
+ HOST=${CHOST}
+ fi
+}
+
+ENV_D="${ROOT}etc/env.d/binutils"
+
+DEBUG="no"
+NEED_ACTION="yes"
+DOIT="switch_profile"
+PROFILE=""
+FAKE_TARGETS_USER=""
+HOST=""
+
+while [[ $# -gt 0 ]] ; do
+ x=$1
+ shift
+ case ${x} in
+ -c|--get-current-profile)
+ if [[ ${NEED_ACTION} == "yes" ]] ; then
+ NEED_ACTION="no"
+ DOIT="get_current_profile"
+ fi
+ ;;
+ -d|--debug)
+ DEBUG="yes"
+ ;;
+ -l|--list-profiles)
+ if [[ ${NEED_ACTION} == "yes" ]] ; then
+ NEED_ACTION="no"
+ DOIT="list_profiles"
+ fi
+ ;;
+ -u|--uninstall)
+ if [[ ${NEED_ACTION} == "yes" ]] ; then
+ NEED_ACTION="no"
+ DOIT="uninstall_target"
+ TARGET=$1
+ shift
+ fi
+ ;;
+ -h|--help)
+ usage
+ exit 0
+ ;;
+ -V|--version)
+ cvsver="$Id$"
+ cvsver=${cvsver##*binutils-config-}
+ bver=${cvsver%%,v *}
+ cvsver=${cvsver#* }
+ echo "binutils-config-${bver} (r${cvsver%% *})"
+ exit 0
+ ;;
+ --amd64|--arm|--mips|--x86)
+ if [[ ${NEED_ACTION} == "yes" ]] ; then
+ # Make sure we have a space after each target
+ NEED_ACTION="no"
+ [[ -z ${PROFILE} ]] && PROFILE="current"
+ case ${x} in
+ --amd64) FAKE_TARGETS_USER="x86_64 ";;
+ --arm) FAKE_TARGETS_USER="arm armeb ";;
+ --x86) FAKE_TARGETS_USER="i386 i486 i586 i686 ";;
+ --mips) FAKE_TARGETS_USER="mips mips64 mipsel mipsel64 ";;
+ esac
+ fi
+ ;;
+ -*)
+ eerror "${0##*/}: Invalid switch! Try '--help'."
+ exit 1
+ ;;
+ *)
+ if [[ -n ${PROFILE} ]] && [[ ${PROFILE} != "current" ]] ; then
+ eerror "${argv0}: Too many arguments! Run ${argv0} without parameters for help."
+ exit 1
+ fi
+
+ if [[ -z $(echo ${x} | tr -d '[:digit:]') ]] ; then
+ # User gave us a # representing the profile
+ i=1
+ for y in "${ENV_D}"/* ; do
+ [[ ${y/config-} != ${y} ]] && continue
+
+ if [[ -f ${y} ]] && [[ ${x} -eq ${i} ]] ; then
+ PROFILE=${y##*/}
+ NEED_ACTION="no"
+ break
+ fi
+ ((++i))
+ done
+ fi
+
+ if [[ -z ${PROFILE} ]] ; then
+ # User gave us a full HOST-ver
+ x=${x##*/}
+ if [[ ! -f ${ENV_D}/${x} ]] && [[ ! -f ${ENV_D}/config-${x} ]] ; then
+ # Maybe they just gave us a ver ...
+ set_HOST
+ if [[ -f ${ENV_D}/${HOST}-${x} ]] ; then
+ x=${HOST}-${x}
+ else
+ eerror "${argv0}: Could not locate '$x' in '${ENV_D}/'!"
+ exit 1
+ fi
+ fi
+ PROFILE=${x}
+ NEED_ACTION="no"
+ fi
+ ;;
+ esac
+done
+
+[[ ${NEED_ACTION} == "yes" ]] && usage && exit 1
+[[ ${DEBUG} == "yes" ]] && set -x
+
+[[ ${DOIT} != "list_profiles" ]] && set_HOST
+[[ -z ${PROFILE} ]] && PROFILE=${HOST}
+[[ ${PROFILE} == "current" ]] && PROFILE=$(PROFILE=${HOST} get_current_profile)
+eval ${DOIT}
+
+# vim:ts=4
diff --git a/sys-devel/binutils-config/files/binutils-config-2 b/sys-devel/binutils-config/files/binutils-config-2
new file mode 100755
index 00000000000..48b9d518ce2
--- /dev/null
+++ b/sys-devel/binutils-config/files/binutils-config-2
@@ -0,0 +1,434 @@
+#!/bin/bash
+# Copyright 1999-2009 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+# Format of /etc/env.d/binutils/:
+# config-TARGET: CURRENT=version for TARGET
+# TARGET-VER: has a TARGET and VER variable
+
+: ${ROOT:=/}
+[[ ${ROOT} != */ ]] && ROOT="${ROOT}/"
+[[ ${ROOT} != /* ]] && ROOT="${PWD}${ROOT}"
+
+cd /
+
+trap ":" INT QUIT TSTP
+
+argv0=${0##*/}
+source /etc/init.d/functions.sh || {
+ echo "${argv0}: Could not source /etc/init.d/functions.sh!" 1>&2
+ exit 1
+}
+esyslog() { :; }
+umask 022
+
+usage() {
+cat << USAGE_END
+
+Usage: ${HILITE}binutils-config${NORMAL} ${GOOD}[options]${NORMAL} ${BRACKET}[binutils profile]${NORMAL}
+
+${HILITE}General Options:${NORMAL}
+ ${GOOD}-c, --get-current-profile${NORMAL} Print current profile
+ ${GOOD}-l, --list-profiles${NORMAL} Print a list of available profiles
+ ${GOOD}-u, --uninstall${NORMAL} Remove all signs of specified target
+ ${GOOD}-d, --debug${NORMAL} Execute with debug output
+
+${HILITE}Arch Specific Cruft:${NORMAL}
+ ${GOOD}--amd64${NORMAL} Install extra amd64 links (x86_64)
+ ${GOOD}--arm${NORMAL} Install extra arm links (arm/armeb)
+ ${GOOD}--mips${NORMAL} Install extra mips links (mips/mipsel)
+ ${GOOD}--x86${NORMAL} Install extra x86 links (i[3-6]86)
+
+Profile names are of the form: ${BRACKET}<CTARGET>-<binutils version>${NORMAL}
+For example: ${BRACKET}i686-pc-linux-gnu-2.15.92.0.2${NORMAL}
+
+For more info, please see ${HILITE}binutils-config${NORMAL}(8).
+USAGE_END
+
+ exit ${1:-1}
+}
+
+mv_if_diff() {
+ if cmp -s "$1" "$2" ; then
+ rm -f "$1"
+ else
+ mv -f "$1" "$2"
+ fi
+}
+
+switch_profile() {
+ unset TARGET VER LIBPATH FAKE_TARGETS
+ source "${ENV_D}/${PROFILE}"
+ if [[ -z ${TARGET} ]] ; then
+ eerror "${PROFILE} is invalid (no \$TARGET defined) :("
+ return 1
+ fi
+ if [[ -z ${VER} ]] ; then
+ eerror "${PROFILE} is invalid (no \$VER defined) :("
+ return 1
+ fi
+
+ #
+ # Older installs don't have 'FAKE_TARGETS' defined, so lets
+ # update these env.d entries so that we don't force the poor
+ # user to re-emerge their binutils just for 1 envvar :/
+ #
+ if [[ ${FAKE_TARGETS-poor user} == "poor user" ]] ; then
+ local targ=${TARGET/-*}
+ local FAKE_TARGETS=${TARGET}
+ case ${targ} in
+ mips|powerpc|sparc)
+ FAKE_TARGETS="${FAKE_TARGETS} ${TARGET/-/64-}";;
+ mips64|powerpc64|sparc64)
+ FAKE_TARGETS="${FAKE_TARGETS} ${TARGET/64-/-}";;
+ esac
+ echo "FAKE_TARGETS=\"${FAKE_TARGETS}\"" >> "${ENV_D}/${PROFILE}"
+ fi
+ local fake_targ_append="${TARGET#*-}"
+ FAKE_TARGETS="${FAKE_TARGETS} ${FAKE_TARGETS_USER// /-${fake_targ_append} }"
+
+ ebegin "Switching to ${PROFILE}"
+
+ #
+ # Generate binary symlinks
+ # On systems that do 32bit/64bit, we need to fake an
+ # extra set of binary names (${FAKE_TARGETS})
+ #
+ BINPATH=""
+ BINPATH_LINKS=""
+ if [[ ${TARGET} != ${HOST} ]] ; then
+ #
+ # Newer paths: /usr/${HOST}/${TARGET}/...
+ # Older paths: /usr/${TARGET}/...
+ #
+ if [[ -d ${ROOT}/usr/${HOST}/${TARGET}/binutils-bin/${VER} ]] ; then
+ BINPATH=/usr/${HOST}/${TARGET}/binutils-bin/${VER}
+ BINPATH_LINKS=/usr/libexec/gcc/${TARGET}
+ fi
+ fi
+ if [[ -z ${BINPATH} ]] ; then
+ BINPATH=/usr/${TARGET}/binutils-bin/${VER}
+ BINPATH_LINKS=/usr/${TARGET}/bin
+ fi
+ cd "${ROOT}/${BINPATH}" || exit 1
+ mkdir -p "${ROOT}/${BINPATH_LINKS}" "${ROOT}/usr/bin"
+ for x in * ; do
+ ln -sf "${BINPATH}/${x}" "${ROOT}/${BINPATH_LINKS}/${x}"
+ ln -sf "${BINPATH_LINKS}/${x}" "${ROOT}"/usr/bin/${TARGET}-${x}
+ for fake in ${FAKE_TARGETS} ; do
+ [[ -f ${ENV_D}/config-${fake} ]] && continue
+ ln -sf "${BINPATH_LINKS}/${x}" "${ROOT}"/usr/bin/${fake}-${x}
+ done
+ if [[ ${TARGET} == ${HOST} ]] ; then
+ ln -sf ${TARGET}-${x} "${ROOT}"/usr/bin/${x}
+ fi
+ done
+
+ #
+ # Generate library / ldscripts symlinks
+ #
+ : ${LIBPATH:=/usr/lib/binutils/${TARGET}/${VER}}
+ cd "${ROOT}/${LIBPATH}" || exit 1
+ if [[ ${TARGET} == ${HOST} ]] ; then
+ dstlib=${ROOT}/usr/${HOST}/lib
+ else
+ dstlib=${ROOT}/usr/${HOST}/${TARGET}/lib
+ # Clean out old path
+ rm -rf "${ROOT}"/usr/${TARGET}/lib/ldscripts
+ rmdir "${ROOT}"/usr/${TARGET}/lib >& /dev/null
+ fi
+ # When upgrading, we need to clean up ldscripts and libs
+ rm -rf "${dstlib}/ldscripts" "${ROOT}/${BINPATH_LINKS}"/ldscripts
+ mkdir -p "${dstlib}"
+ ln -sf "${LIBPATH}/ldscripts" "${dstlib}"/ldscripts
+ find -L "${dstlib}" -type l -exec rm {} +
+ for x in lib* ; do
+ ln -sf "${LIBPATH}/${x}" "${dstlib}/${x}"
+ done
+
+ #
+ # Generate include symlinks
+ #
+ INCPATH=${LIBPATH}/include
+ if [[ -d ${ROOT}/${INCPATH} ]] ; then
+ cd "${ROOT}/${INCPATH}" || exit 1
+ if [[ ${HOST} == ${TARGET} ]] ; then
+ mkdir -p "${ROOT}/usr/include"
+ for x in * ; do
+ ln -sf "${INCPATH}/${x}" "${ROOT}/usr/include/${x}"
+ done
+ else
+ # Clean out old path -- cannot use '-exec {} +' syntax here
+ find . -type f -exec rm -f "${ROOT}/usr/${TARGET}/usr/include/{}" \;
+ rmdir "${ROOT}/usr/${TARGET}/usr/include" >& /dev/null
+ rmdir "${ROOT}/usr/${TARGET}/usr" >& /dev/null
+ rmdir "${ROOT}/usr/${TARGET}" >& /dev/null
+ fi
+ fi
+
+ #
+ # Make sure proper paths get updated
+ #
+ if [[ ${TARGET} == ${HOST} ]] ; then
+ DATAPATH=/usr/share/binutils-data/${TARGET}/${VER}
+ local e="${ROOT}"/etc/env.d/05binutils
+ local ee="${e}.tmp"
+ rm -f "${ee}"
+ [[ -d ${DATAPATH}/man ]] && echo "MANPATH=${DATAPATH}/man" >> "${ee}"
+ [[ -d ${DATAPATH}/info ]] && echo "INFOPATH=${DATAPATH}/info" >> "${ee}"
+ # hmm, `ld` has this in SEARCH_DIR(), but ld.so does not ...
+ if [[ -d ${ROOT}/etc/ld.so.conf.d ]] ; then
+ local l="${ROOT}"/etc/ld.so.conf.d/05binutils.conf
+ local ll="${l}.tmp"
+ echo "/usr/${TARGET}/lib" > "${ll}"
+ mv_if_diff "${ll}" "${l}"
+ else
+ echo "LDPATH=/usr/${TARGET}/lib" >> "${ee}"
+ fi
+ mv_if_diff "${ee}" "${e}"
+ fi
+
+ local c="${ENV_D}/config-${TARGET}"
+ local cc="${c}.tmp"
+ echo "CURRENT=${VER}" > "${cc}"
+ mv_if_diff "${cc}" "${c}"
+
+ eend 0
+
+ #
+ # Regen env.d if need/can be
+ #
+ if [[ ${ROOT} == "/" ]] && [[ ${TARGET} == ${HOST} ]] ; then
+ env-update
+ echo
+ ewarn "Please remember to run:"
+ echo
+ ewarn " # . /etc/profile"
+ echo
+ fi
+
+ return 0
+}
+
+uninstall_target() {
+ if [[ ${TARGET} == ${HOST} ]] ; then
+ eerror "${argv0}: Refusing to uninstall native binutils"
+ exit 1
+ fi
+
+ shopt -s nullglob
+ PROFILE=""
+
+ for PROFILE in "${ENV_D}"/${TARGET}-* ; do
+ ewarn "Removing all signs of ${PROFILE##*/}"
+ rm -f "${ENV_D}"/${PROFILE}
+ done
+ if [[ -z ${PROFILE} ]] && [[ ! -e ${ENV_D}/config-${TARGET} ]] ; then
+ eerror "${argv0}: No profiles exist for '${TARGET}'"
+ exit 1
+ fi
+
+ rm -f "${ENV_D}"/config-${TARGET} "${ROOT}"/etc/ld.so.conf.d/05binutils.conf
+
+ # XXX: we still leave behind FAKE_TARGETS in /usr/bin ...
+ for x in addr2line ar as c++filt elf2flt flthdr gprof ld ld.real \
+ nm objcopy objdump ranlib readelf size strings strip ; do
+ rm -f "${ROOT}"/usr/bin/${TARGET}-${x}
+ rm -f "${ROOT}"/usr/{${HOST}/,}${TARGET}/bin/${x}
+ rm -f "${ROOT}"/usr/libexec/gcc/${TARGET}/${x}
+ done
+ for x in ansidecl.h bfd.h bfdlink.h dis-asm.h symcat.h ; do
+ rm -f "${ROOT}"/usr/{${HOST}/,}${TARGET}/{usr/,}include/${x}
+ done
+ for x in bfd iberty opcodes ; do
+ rm -f "${ROOT}"/usr/${HOST}/${TARGET}/lib/lib${x}{{-*,}.so,.a,.la}
+ done
+ # Delete broken symlinks
+ local destdir="${ROOT}/usr/${HOST}/${TARGET}"
+ rm -f "${destdir}"/lib/ldscripts
+ find -L "${destdir}"/lib -type l -exec rm {} +
+ rmdir \
+ "${destdir}"/{bin,include,lib,usr} \
+ "${destdir}" \
+ "${ROOT}"/var/db/pkg/cross-${TARGET} \
+ 2>/dev/null
+
+ rm -f "${ENV_D}"/${TARGET}-*
+}
+
+get_current_profile() {
+ if [[ ! -f ${ENV_D}/config-${PROFILE} ]] ; then
+ eerror "${argv0}: No binutils profile is active!"
+ return 1
+ fi
+
+ source "${ENV_D}/config-${PROFILE}"
+
+ if [[ -z ${CURRENT} ]] ; then
+ eerror "${argv0}: No binutils profile is active!"
+ return 1
+ fi
+
+ echo "${PROFILE}-${CURRENT}"
+
+ return 0
+}
+
+list_profiles() {
+ local i=1
+
+ set_HOST
+
+ if [[ ${ROOT} != / ]] ; then
+ echo "Using binutils-config info in ${ROOT}"
+ fi
+ target=
+ for x in "${ENV_D}"/* ; do
+ if [[ -f ${x} ]] && [[ ${x/\/config-} == ${x} ]] ; then
+ source "${x}"
+ if [[ ${target} != ${TARGET} ]] ; then
+ [[ -n ${target} ]] && echo
+ target=${TARGET}
+ fi
+
+ x=${x##*/}
+ if [[ -e ${ENV_D}/config-${TARGET} ]] ; then
+ source "${ENV_D}/config-${TARGET}"
+ if [[ ${VER} == ${CURRENT} ]] ; then
+ [[ ${TARGET} == ${HOST} ]] \
+ && x="${x} ${GOOD}*${NORMAL}" \
+ || x="${x} ${HILITE}*${NORMAL}"
+ fi
+ fi
+ echo " [${i}] ${x}"
+ ((++i))
+ fi
+ done
+}
+
+set_HOST() {
+ [[ -n ${HOST} ]] && return 0
+
+ if [[ -z ${CHOST} ]] ; then
+ HOST=$(portageq envvar CHOST)
+ else
+ HOST=${CHOST}
+ fi
+}
+
+ENV_D="${ROOT}etc/env.d/binutils"
+
+DEBUG="no"
+NEED_ACTION="yes"
+DOIT="switch_profile"
+PROFILE=""
+FAKE_TARGETS_USER=""
+HOST=""
+
+while [[ $# -gt 0 ]] ; do
+ x=$1
+ shift
+ case ${x} in
+ -c|--get-current-profile)
+ if [[ ${NEED_ACTION} == "yes" ]] ; then
+ NEED_ACTION="no"
+ DOIT="get_current_profile"
+ fi
+ ;;
+ -d|--debug)
+ DEBUG="yes"
+ ;;
+ -l|--list-profiles)
+ if [[ ${NEED_ACTION} == "yes" ]] ; then
+ NEED_ACTION="no"
+ DOIT="list_profiles"
+ fi
+ ;;
+ -u|--uninstall)
+ if [[ ${NEED_ACTION} == "yes" ]] ; then
+ NEED_ACTION="no"
+ DOIT="uninstall_target"
+ TARGET=$1
+ shift
+ fi
+ ;;
+ -h|--help)
+ usage 0
+ ;;
+ -V|--version)
+ unset Header
+ cvsver="$Id$"
+ cvsver=${cvsver##*binutils-config-}
+ bver=${cvsver%%,v *}
+ cvsver=${cvsver#* }
+ echo "binutils-config-${bver} (r${cvsver%% *})"
+ exit 0
+ ;;
+ --amd64|--arm|--mips|--x86)
+ if [[ ${NEED_ACTION} == "yes" ]] ; then
+ # Make sure we have a space after each target
+ NEED_ACTION="no"
+ [[ -z ${PROFILE} ]] && PROFILE="current"
+ case ${x} in
+ --amd64) FAKE_TARGETS_USER="x86_64 ";;
+ --arm) FAKE_TARGETS_USER="arm armeb ";;
+ --x86) FAKE_TARGETS_USER="i386 i486 i586 i686 ";;
+ --mips) FAKE_TARGETS_USER="mips mips64 mipsel mipsel64 ";;
+ esac
+ fi
+ ;;
+ -*)
+ eerror "${0##*/}: Invalid switch! Try '--help'."
+ exit 1
+ ;;
+ *)
+ if [[ -n ${PROFILE} ]] && [[ ${PROFILE} != "current" ]] ; then
+ eerror "${argv0}: Too many arguments! Run ${argv0} without parameters for help."
+ exit 1
+ fi
+
+ if [[ -z $(echo ${x} | tr -d '[:digit:]') ]] ; then
+ # User gave us a # representing the profile
+ i=1
+ for y in "${ENV_D}"/* ; do
+ [[ ${y/config-} != ${y} ]] && continue
+
+ if [[ -f ${y} ]] && [[ ${x} -eq ${i} ]] ; then
+ PROFILE=${y##*/}
+ NEED_ACTION="no"
+ break
+ fi
+ ((++i))
+ done
+ fi
+
+ if [[ -z ${PROFILE} ]] ; then
+ # User gave us a full HOST-ver
+ x=${x##*/}
+ if [[ ! -f ${ENV_D}/${x} ]] && [[ ! -f ${ENV_D}/config-${x} ]] ; then
+ # Maybe they just gave us a ver ...
+ set_HOST
+ if [[ -f ${ENV_D}/${HOST}-${x} ]] ; then
+ x=${HOST}-${x}
+ else
+ eerror "${argv0}: Could not locate '$x' in '${ENV_D}/'!"
+ exit 1
+ fi
+ fi
+ PROFILE=${x}
+ NEED_ACTION="no"
+ fi
+ ;;
+ esac
+done
+
+[[ ${NEED_ACTION} == "yes" ]] && usage 1
+[[ ${DEBUG} == "yes" ]] && set -x
+
+[[ ${DOIT} != "list_profiles" ]] && set_HOST
+[[ -z ${PROFILE} ]] && PROFILE=${HOST}
+[[ ${PROFILE} == "current" ]] && PROFILE=$(PROFILE=${HOST} get_current_profile)
+eval ${DOIT}
+
+# vim:ts=4
diff --git a/sys-devel/binutils-config/files/binutils-config-3 b/sys-devel/binutils-config/files/binutils-config-3
new file mode 100755
index 00000000000..a9e94124170
--- /dev/null
+++ b/sys-devel/binutils-config/files/binutils-config-3
@@ -0,0 +1,509 @@
+#!/bin/bash
+# Copyright 1999-2013 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+# Format of /etc/env.d/binutils/:
+# config-TARGET: CURRENT=version for TARGET
+# TARGET-VER: has a TARGET and VER variable
+
+: ${ROOT:=/}
+[[ ${ROOT} != */ ]] && ROOT="${ROOT}/"
+[[ ${ROOT} != /* ]] && ROOT="${PWD%/}/${ROOT}"
+
+cd /
+
+trap ":" INT QUIT TSTP
+
+argv0=${0##*/}
+source /etc/init.d/functions.sh || {
+ echo "${argv0}: Could not source /etc/init.d/functions.sh!" 1>&2
+ exit 1
+}
+esyslog() { :; }
+die() { eerror "${argv0}: $*"; exit 1; }
+umask 022
+
+usage() {
+cat << USAGE_END
+Usage: ${HILITE}binutils-config${NORMAL} ${GOOD}[options]${NORMAL} ${BRACKET}[binutils profile]${NORMAL}
+
+${HILITE}General Options:${NORMAL}
+ ${GOOD}-c, --get-current-profile${NORMAL} Print current profile
+ ${GOOD}-l, --list-profiles${NORMAL} Print a list of available profiles
+ ${GOOD}-u, --uninstall${NORMAL} Remove all signs of specified target
+ ${GOOD}-d, --debug${NORMAL} Execute with debug output
+
+${HILITE}General Cruft:${NORMAL}
+ ${GOOD}--linker${NORMAL} <linker> Switch to specified linker (if supported)
+
+${HILITE}Arch Specific Cruft:${NORMAL}
+ ${GOOD}--amd64${NORMAL} Install extra amd64 links (x86_64)
+ ${GOOD}--arm${NORMAL} Install extra arm links (arm/armeb)
+ ${GOOD}--mips${NORMAL} Install extra mips links (mips/mipsel)
+ ${GOOD}--x86${NORMAL} Install extra x86 links (i[3-6]86)
+
+Profile names are of the form: ${BRACKET}<CTARGET>-<binutils version>${NORMAL}
+For example: ${BRACKET}i686-pc-linux-gnu-2.15.92.0.2${NORMAL}
+
+For more info, please see ${HILITE}binutils-config${NORMAL}(8).
+USAGE_END
+
+ exit ${1:-1}
+}
+
+mv_if_diff() {
+ if cmp -s "$1" "$2" ; then
+ rm -f "$1"
+ else
+ mv -f "$1" "$2"
+ fi
+}
+atomic_ln() {
+ local target=$1 linkdir=$2 linkname=$3 linktmp linkfull
+ linktmp="${linkdir}/.binutils-config.tmp.${linkname}"
+ linkfull="${linkdir}/${linkname}"
+ if [[ -d ${linkfull} ]] ; then
+ # if linking to a dir, we need a little magic to
+ # make it atomic since `mv -T` is not portable
+ rm -rf "${linktmp}"
+ mkdir -p "${linktmp}"
+ ln -sf "${target}" "${linktmp}/${linkname}"
+ mv "${linktmp}/${linkname}" "${linktmp}/../"
+ rmdir "${linktmp}"
+ else
+ # `ln` will expand into unlink();symlink(); which
+ # is not atomic for a small amount of time, but
+ # `mv` is a single rename() call
+ ln -sf "${target}" "${linktmp}"
+ mv "${linktmp}" "${linkfull}"
+ fi
+}
+
+setup_env() {
+ unset TARGET VER LIBPATH FAKE_TARGETS
+ source "${ENV_D}/${PROFILE}"
+ if [[ -z ${TARGET} ]] ; then
+ eerror "${PROFILE} is invalid (no \$TARGET defined) :("
+ return 1
+ fi
+ if [[ -z ${VER} ]] ; then
+ eerror "${PROFILE} is invalid (no \$VER defined) :("
+ return 1
+ fi
+
+ #
+ # Older installs don't have 'FAKE_TARGETS' defined, so lets
+ # update these env.d entries so that we don't force the poor
+ # user to re-emerge their binutils just for 1 envvar :/
+ #
+ if [[ ${FAKE_TARGETS-poor user} == "poor user" ]] ; then
+ local targ=${TARGET/-*}
+ local FAKE_TARGETS=${TARGET}
+ case ${targ} in
+ mips|powerpc|sparc)
+ FAKE_TARGETS="${FAKE_TARGETS} ${TARGET/-/64-}";;
+ mips64|powerpc64|sparc64)
+ FAKE_TARGETS="${FAKE_TARGETS} ${TARGET/64-/-}";;
+ esac
+ echo "FAKE_TARGETS=\"${FAKE_TARGETS}\"" >> "${ENV_D}/${PROFILE}"
+ fi
+ local fake_targ_append="${TARGET#*-}"
+ FAKE_TARGETS="${FAKE_TARGETS} ${FAKE_TARGETS_USER// /-${fake_targ_append} }"
+
+ #
+ # Generate binary symlinks
+ # On systems that do 32bit/64bit, we need to fake an
+ # extra set of binary names (${FAKE_TARGETS})
+ #
+ BINPATH=""
+ BINPATH_LINKS=""
+ if [[ ${TARGET} != ${HOST} ]] ; then
+ #
+ # Newer paths: /usr/${HOST}/${TARGET}/...
+ # Older paths: /usr/${TARGET}/...
+ #
+ if [[ -d ${ROOT}/usr/${HOST}/${TARGET}/binutils-bin/${VER} ]] ; then
+ BINPATH=/usr/${HOST}/${TARGET}/binutils-bin/${VER}
+ BINPATH_LINKS=/usr/libexec/gcc/${TARGET}
+ fi
+ fi
+ if [[ -z ${BINPATH} ]] ; then
+ BINPATH=/usr/${TARGET}/binutils-bin/${VER}
+ BINPATH_LINKS=/usr/${TARGET}/bin
+ fi
+}
+
+switch_profile() {
+ ebegin "Switching to ${PROFILE}"
+
+ setup_env || return 1
+
+ cd "${ROOT}/${BINPATH}" || exit 1
+ mkdir -p "${ROOT}/${BINPATH_LINKS}" "${ROOT}/usr/bin"
+ for x in * ; do
+ atomic_ln "${BINPATH}/${x}" "${ROOT}/${BINPATH_LINKS}" "${x}"
+ atomic_ln "${BINPATH_LINKS}/${x}" "${ROOT}/usr/bin/" "${TARGET}-${x}"
+ for fake in ${FAKE_TARGETS} ; do
+ [[ -f ${ENV_D}/config-${fake} ]] && continue
+ atomic_ln "${BINPATH_LINKS}/${x}" "${ROOT}/usr/bin" "${fake}-${x}"
+ done
+ if [[ ${TARGET} == ${HOST} ]] ; then
+ atomic_ln "${TARGET}-${x}" "${ROOT}/usr/bin" "${x}"
+ fi
+ done
+
+ #
+ # Generate library / ldscripts symlinks
+ #
+ : ${LIBPATH:=/usr/lib/binutils/${TARGET}/${VER}}
+ cd "${ROOT}/${LIBPATH}" || exit 1
+ if [[ ${TARGET} == ${HOST} ]] ; then
+ dstlib=${ROOT}/usr/${HOST}/lib
+ else
+ dstlib=${ROOT}/usr/${HOST}/${TARGET}/lib
+ fi
+ # When upgrading, we need to clean up ldscripts and libs
+ mkdir -p "${dstlib}"
+ rm -rf "${ROOT}/${BINPATH_LINKS}"/ldscripts
+ atomic_ln "${LIBPATH}/ldscripts" "${dstlib}" "ldscripts"
+ find -L "${dstlib}" -type l -exec rm -v {} +
+ for x in lib* ; do
+ atomic_ln "${LIBPATH}/${x}" "${dstlib}" "${x}"
+ done
+
+ #
+ # Generate include symlinks
+ #
+ INCPATH=${LIBPATH}/include
+ if [[ -d ${ROOT}/${INCPATH} ]] ; then
+ cd "${ROOT}/${INCPATH}" || exit 1
+ if [[ ${HOST} == ${TARGET} ]] ; then
+ mkdir -p "${ROOT}/usr/include"
+ for x in * ; do
+ atomic_ln "${INCPATH}/${x}" "${ROOT}/usr/include" "${x}"
+ done
+ else
+ # Clean out old path -- cannot use '-exec {} +' syntax here
+ find . -type f -exec rm -f "${ROOT}/usr/${TARGET}/usr/include/{}" \;
+ rmdir "${ROOT}/usr/${TARGET}/usr/include" >& /dev/null
+ rmdir "${ROOT}/usr/${TARGET}/usr" >& /dev/null
+ rmdir "${ROOT}/usr/${TARGET}" >& /dev/null
+ fi
+ fi
+
+ #
+ # Make sure proper paths get updated
+ #
+ if [[ ${TARGET} == ${HOST} ]] ; then
+ DATAPATH=/usr/share/binutils-data/${TARGET}/${VER}
+ local e="${ROOT}"/etc/env.d/05binutils
+ local ee="${e}.tmp"
+ rm -f "${ee}"
+ [[ -d ${DATAPATH}/man ]] && echo "MANPATH=${DATAPATH}/man" >> "${ee}"
+ [[ -d ${DATAPATH}/info ]] && echo "INFOPATH=${DATAPATH}/info" >> "${ee}"
+ # hmm, `ld` has this in SEARCH_DIR(), but ld.so does not ...
+ if [[ -d ${ROOT}/etc/ld.so.conf.d ]] ; then
+ local l="${ROOT}"/etc/ld.so.conf.d/05binutils.conf
+ local ll="${l}.tmp"
+ echo "/usr/${TARGET}/lib" > "${ll}"
+ mv_if_diff "${ll}" "${l}"
+ else
+ echo "LDPATH=/usr/${TARGET}/lib" >> "${ee}"
+ fi
+ mv_if_diff "${ee}" "${e}"
+ fi
+
+ local c="${ENV_D}/config-${TARGET}"
+ local cc="${c}.tmp"
+ echo "CURRENT=${VER}" > "${cc}"
+ mv_if_diff "${cc}" "${c}"
+
+ eend 0
+
+ #
+ # Regen env.d if need/can be
+ #
+ if [[ ${ROOT} == "/" ]] && [[ ${TARGET} == ${HOST} ]] ; then
+ env-update
+ echo
+ ewarn "Please remember to run:"
+ echo
+ ewarn " # . /etc/profile"
+ echo
+ fi
+
+ return 0
+}
+
+uninstall_target() {
+ : ${TARGET:=${UARG}}
+
+ if [[ ${TARGET} == ${HOST} ]] ; then
+ die "refusing to uninstall native binutils"
+ fi
+
+ shopt -s nullglob
+ PROFILE=""
+
+ for PROFILE in "${ENV_D}"/${TARGET}-* ; do
+ ewarn "Removing all signs of ${PROFILE##*/}"
+ rm -f "${ENV_D}"/${PROFILE}
+ done
+ if [[ -z ${PROFILE} ]] && [[ ! -e ${ENV_D}/config-${TARGET} ]] ; then
+ die "no profiles exist for '${TARGET}'"
+ fi
+
+ rm -f "${ENV_D}"/config-${TARGET} "${ROOT}"/etc/ld.so.conf.d/05binutils.conf
+
+ # XXX: we still leave behind FAKE_TARGETS in /usr/bin ...
+ local x
+ for x in \
+ addr2line ar as c++filt elf2flt elfedit flthdr gprof \
+ ld ld.{bfd,gold,real} \
+ nm objcopy objdump ranlib readelf size strings strip
+ do
+ x=(
+ "${ROOT}"/usr/bin/${TARGET}-${x}
+ "${ROOT}"/usr/{${HOST}/,}${TARGET}/bin/${x}
+ "${ROOT}"/usr/libexec/gcc/${TARGET}/${x}
+ )
+ rm -f "${x[@]}"
+ done
+ for x in ansidecl.h bfd.h bfdlink.h dis-asm.h symcat.h ; do
+ rm -f "${ROOT}"/usr/{${HOST}/,}${TARGET}/{usr/,}include/${x}
+ done
+ for x in bfd iberty opcodes ; do
+ rm -f "${ROOT}"/usr/${HOST}/${TARGET}/lib/lib${x}{{-*,}.so,.a,.la}
+ done
+ # Delete broken symlinks
+ local destdir="${ROOT}/usr/${HOST}/${TARGET}"
+ rm -f "${destdir}"/lib/ldscripts
+ find -L "${destdir}"/lib -type l -exec rm {} +
+ rmdir \
+ "${destdir}"/{bin,include,lib,usr} \
+ "${destdir}" \
+ "${ROOT}"/var/db/pkg/cross-${TARGET} \
+ "${ROOT}"/usr/{${HOST}/,}${TARGET}/bin \
+ "${ROOT}"/usr/libexec/gcc/${TARGET} \
+ 2>/dev/null
+
+ rm -f "${ENV_D}"/${TARGET}-*
+}
+
+set_current_profile() {
+ if [[ ! -f ${ENV_D}/config-${TARGET} ]] ; then
+ eerror "${argv0}: unable to locate a profile for target: ${TARGET}"
+ return 1
+ fi
+
+ source "${ENV_D}/config-${TARGET}"
+
+ if [[ -z ${CURRENT} ]] ; then
+ eerror "${argv0}: no binutils profile is active!"
+ return 1
+ fi
+
+ echo "${TARGET}-${CURRENT}"
+
+ return 0
+}
+get_current_profile() { echo "${PROFILE}" ; }
+
+list_profiles() {
+ local x i target
+
+ if [[ ${ROOT} != / ]] ; then
+ echo "Using binutils-config info in ${ROOT}"
+ fi
+
+ set -- "${ENV_D}"/*
+ target=
+ i=1
+
+ for x ; do
+ # skip broken links and config files
+ [[ -f ${x} ]] || continue
+ [[ ${x} == */config-* ]] && continue
+
+ source "${x}"
+ if [[ ${target} != ${TARGET} ]] ; then
+ [[ -n ${target} ]] && echo
+ target=${TARGET}
+ fi
+
+ x=${x##*/}
+ if [[ -e ${ENV_D}/config-${TARGET} ]] ; then
+ source "${ENV_D}/config-${TARGET}"
+ if [[ ${VER} == ${CURRENT} ]] ; then
+ [[ ${TARGET} == ${HOST} ]] \
+ && x="${x} ${GOOD}*${NORMAL}" \
+ || x="${x} ${HILITE}*${NORMAL}"
+ fi
+ fi
+
+ # We would align the [...] field like so:
+ #printf ' [%*ss] %s\n' ${##} "${i}" "${x}"
+ # but this breaks simple scripting: `binutils -l | awk '{print $2}'`
+
+ # Or we could align the target col like so:
+ #printf ' [%s]%*s %s\n' "${i}" $(( ${##} - ${#i} )) "" "${x}"
+ # but i'm not sold that it looks better
+
+ # So keep it simple ... only makes a diff anyways for crazy people
+ # like me which have 100+ binutils packages installed ...
+ echo " [$i] ${x}"
+ ((++i))
+ done
+}
+
+switch_linker() {
+ local bpath ld=$1
+
+ case ${ld} in
+ ld.*) ;;
+ *) die "not supported: linker must start with 'ld.'" ;;
+ esac
+
+ setup_env || return 1
+ bpath="${ROOT}/${BINPATH}"
+
+ # does this binutils even support the requested linker ?
+ if [[ ! -e ${bpath}/${ld} ]] ; then
+ die "sorry, but ${PROFILE} doesn't support the ${ld} linker"
+ fi
+
+ # switch it up
+ ebegin "Setting default linker to ${ld} for ${PROFILE}"
+ atomic_ln ${ld} "${bpath}" ld
+ eend $?
+}
+
+set_HOST() {
+ # Set HOST to CHOST if it isn't already set
+ : ${HOST:=${CHOST:-$(portageq envvar CHOST)}}
+}
+
+ENV_D="${ROOT}etc/env.d/binutils"
+
+DEBUG="no"
+NEED_ACTION="yes"
+DOIT="switch_profile"
+PROFILE="current"
+FAKE_TARGETS_USER=""
+HOST=""
+TARGET=""
+unset UARG
+
+select_action() {
+ if [[ ${NEED_ACTION} != "no" ]] ; then
+ NEED_ACTION="no"
+ DOIT=$1
+ else
+ die "one action at a time!"
+ fi
+}
+
+while [[ $# -gt 0 ]] ; do
+ x=$1
+ shift
+ case ${x} in
+ -c|--get-current-profile) select_action get_current_profile ;;
+ -l|--list|--list-profiles) select_action list_profiles ;;
+ -u|--uninstall) select_action uninstall_target ;;
+ --linker) select_action "switch_linker $1"; shift ;;
+ -d|--debug) DEBUG="yes" ;;
+ -h|--help) usage 0 ;;
+ -V|--version)
+ unset Header
+ cvsver="$Id$"
+ cvsver=${cvsver##*binutils-config-}
+ bver=${cvsver%%,v *}
+ cvsver=${cvsver#* }
+ echo "binutils-config-${bver} (r${cvsver%% *})"
+ exit 0
+ ;;
+ --amd64|--arm|--mips|--x86)
+ if [[ ${NEED_ACTION} == "yes" ]] ; then
+ # Make sure we have a space after each target
+ NEED_ACTION="no"
+ case ${x} in
+ --amd64) FAKE_TARGETS_USER="x86_64 ";;
+ --arm) FAKE_TARGETS_USER="arm armeb ";;
+ --x86) FAKE_TARGETS_USER="i386 i486 i586 i686 ";;
+ --mips) FAKE_TARGETS_USER="mips mips64 mipsel mipsel64 ";;
+ esac
+ fi
+ ;;
+ -*)
+ die "invalid switch! Try '--help'."
+ ;;
+ *)
+ if [[ ${UARG+set} == "set" ]] ; then
+ die "only one profile/target at a time please"
+ fi
+ NEED_ACTION="maybe"
+ UARG=${x}
+ ;;
+ esac
+done
+
+[[ ${NEED_ACTION} == "yes" ]] && usage 1
+[[ ${DEBUG} == "yes" ]] && set -x
+
+# All operations need to know the current HOST to figure out
+# what is a native target and what is a cross target
+set_HOST
+
+# All operations need to know the profile the user wants
+case ${DOIT} in
+switch_profile|switch_linker_*)
+ # decode user's profile choice
+ x=${UARG:-$(TARGET=${HOST} set_current_profile)}
+ PROFILE=""
+ if [[ -z $(echo ${x} | tr -d '[:digit:]') ]] ; then
+ # User gave us a # representing the profile
+ i=1
+ for y in "${ENV_D}"/* ; do
+ [[ ${y/config-} != ${y} ]] && continue
+
+ if [[ -f ${y} ]] && [[ ${x} -eq ${i} ]] ; then
+ PROFILE=${y##*/}
+ break
+ fi
+ ((++i))
+ done
+ fi
+
+ if [[ -z ${PROFILE} ]] ; then
+ # User gave us a full HOST-ver
+ x=${x##*/}
+ if [[ -f ${ENV_D}/${x} ]] ; then
+ # Valid HOST-ver yeah!
+ PROFILE=${x}
+ else
+ # Not a valid HOST-ver ...
+ if [[ ! -f ${ENV_D}/config-${x} ]] ; then
+ # Maybe they just gave us a ver ...
+ if [[ -f ${ENV_D}/${HOST}-${x} ]] ; then
+ x=${HOST}-${x}
+ else
+ die "could not locate '$x' in '${ENV_D}/'!"
+ fi
+ PROFILE=${x}
+ else
+ # Maybe they just gave us a target ... pick active profile
+ PROFILE=$(TARGET=${x} set_current_profile)
+ fi
+ fi
+ fi
+ ;;
+*)
+ # lookup current profile as the user gave us a target
+ PROFILE=$(TARGET=${UARG:-${HOST}} set_current_profile) || exit 1
+ ;;
+esac
+
+eval ${DOIT}
+
+# vim:ts=4
diff --git a/sys-devel/binutils-config/files/binutils-config-4 b/sys-devel/binutils-config/files/binutils-config-4
new file mode 100755
index 00000000000..18fc00d8711
--- /dev/null
+++ b/sys-devel/binutils-config/files/binutils-config-4
@@ -0,0 +1,465 @@
+#!/bin/bash
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+# Format of /etc/env.d/binutils/:
+# config-TARGET: CURRENT=version for TARGET
+# TARGET-VER: has a TARGET and VER variable
+
+: ${ROOT:=/}
+[[ ${ROOT} != */ ]] && ROOT="${ROOT}/"
+[[ ${ROOT} != /* ]] && ROOT="${PWD%/}/${ROOT}"
+
+cd /
+
+trap ":" INT QUIT TSTP
+
+argv0=${0##*/}
+FUNCTIONS_SH="/lib/gentoo/functions.sh"
+source ${FUNCTIONS_SH} || {
+ echo "${argv0}: Could not source ${FUNCTIONS_SH}!" 1>&2
+ exit 1
+}
+esyslog() { :; }
+die() { eerror "${argv0}: $*"; exit 1; }
+umask 022
+
+usage() {
+cat << USAGE_END
+Usage: ${HILITE}binutils-config${NORMAL} ${GOOD}[options]${NORMAL} ${BRACKET}[binutils profile]${NORMAL}
+
+${HILITE}General Options:${NORMAL}
+ ${GOOD}-c, --get-current-profile${NORMAL} Print current profile
+ ${GOOD}-l, --list-profiles${NORMAL} Print a list of available profiles
+ ${GOOD}-u, --uninstall${NORMAL} Remove all signs of specified target
+ ${GOOD}-d, --debug${NORMAL} Execute with debug output
+
+${HILITE}General Cruft:${NORMAL}
+ ${GOOD}--linker${NORMAL} <linker> Switch to specified linker (if supported)
+
+Profile names are of the form: ${BRACKET}<CTARGET>-<binutils version>${NORMAL}
+For example: ${BRACKET}i686-pc-linux-gnu-2.15.92.0.2${NORMAL}
+
+For more info, please see ${HILITE}binutils-config${NORMAL}(8).
+USAGE_END
+
+ exit ${1:-1}
+}
+
+mv_if_diff() {
+ if cmp -s "$1" "$2" ; then
+ rm -f "$1"
+ else
+ mv -f "$1" "$2"
+ fi
+}
+atomic_ln() {
+ local target=$1 linkdir=$2 linkname=$3 linktmp linkfull
+ linktmp="${linkdir}/.binutils-config.tmp.${linkname}"
+ linkfull="${linkdir}/${linkname}"
+ if [[ -d ${linkfull} ]] ; then
+ # if linking to a dir, we need a little magic to
+ # make it atomic since `mv -T` is not portable
+ rm -rf "${linktmp}"
+ mkdir -p "${linktmp}"
+ ln -sf "${target}" "${linktmp}/${linkname}"
+ mv "${linktmp}/${linkname}" "${linktmp}/../"
+ rmdir "${linktmp}"
+ else
+ # `ln` will expand into unlink();symlink(); which
+ # is not atomic for a small amount of time, but
+ # `mv` is a single rename() call
+ ln -sf "${target}" "${linktmp}"
+ mv "${linktmp}" "${linkfull}"
+ fi
+}
+
+setup_env() {
+ unset TARGET VER LIBPATH
+ source "${ENV_D}/${PROFILE}"
+ if [[ -z ${TARGET} ]] ; then
+ eerror "${PROFILE} is invalid (no \$TARGET defined) :("
+ return 1
+ fi
+ if [[ -z ${VER} ]] ; then
+ eerror "${PROFILE} is invalid (no \$VER defined) :("
+ return 1
+ fi
+
+ #
+ # Generate binary symlinks
+ #
+ BINPATH=""
+ BINPATH_LINKS=""
+ if [[ ${TARGET} != ${HOST} ]] ; then
+ #
+ # Newer paths: /usr/${HOST}/${TARGET}/...
+ # Older paths: /usr/${TARGET}/...
+ #
+ if [[ -d ${ROOT}/usr/${HOST}/${TARGET}/binutils-bin/${VER} ]] ; then
+ BINPATH=/usr/${HOST}/${TARGET}/binutils-bin/${VER}
+ BINPATH_LINKS=/usr/libexec/gcc/${TARGET}
+ fi
+ fi
+ if [[ -z ${BINPATH} ]] ; then
+ BINPATH=/usr/${TARGET}/binutils-bin/${VER}
+ BINPATH_LINKS=/usr/${TARGET}/bin
+ fi
+}
+
+switch_profile() {
+ ebegin "Switching to ${PROFILE}"
+
+ setup_env || return 1
+
+ cd "${ROOT}/${BINPATH}" || exit 1
+ mkdir -p "${ROOT}/${BINPATH_LINKS}" "${ROOT}/usr/bin"
+ for x in * ; do
+ atomic_ln "${BINPATH}/${x}" "${ROOT}/${BINPATH_LINKS}" "${x}"
+ atomic_ln "${BINPATH_LINKS}/${x}" "${ROOT}/usr/bin" "${TARGET}-${x}"
+ if [[ ${TARGET} == ${HOST} ]] ; then
+ atomic_ln "${TARGET}-${x}" "${ROOT}/usr/bin" "${x}"
+ fi
+ done
+
+ #
+ # Generate library / ldscripts symlinks
+ #
+ : ${LIBPATH:=/usr/lib/binutils/${TARGET}/${VER}}
+ cd "${ROOT}/${LIBPATH}" || exit 1
+ if [[ ${TARGET} == ${HOST} ]] ; then
+ dstlib=${ROOT}/usr/${HOST}/lib
+ else
+ dstlib=${ROOT}/usr/${HOST}/${TARGET}/lib
+ fi
+ # When upgrading, we need to clean up ldscripts and libs
+ mkdir -p "${dstlib}"
+ rm -rf "${ROOT}/${BINPATH_LINKS}"/ldscripts
+ atomic_ln "${LIBPATH}/ldscripts" "${dstlib}" "ldscripts"
+ find -L "${dstlib}" -type l -exec rm -v {} +
+ for x in lib* ; do
+ atomic_ln "${LIBPATH}/${x}" "${dstlib}" "${x}"
+ done
+
+ #
+ # Generate include symlinks
+ #
+ INCPATH=${LIBPATH}/include
+ if [[ -d ${ROOT}/${INCPATH} ]] ; then
+ cd "${ROOT}/${INCPATH}" || exit 1
+ if [[ ${HOST} == ${TARGET} ]] ; then
+ mkdir -p "${ROOT}/usr/include"
+ for x in * ; do
+ atomic_ln "${INCPATH}/${x}" "${ROOT}/usr/include" "${x}"
+ done
+ else
+ # Clean out old path -- cannot use '-exec {} +' syntax here
+ find . -type f -exec rm -f "${ROOT}/usr/${TARGET}/usr/include/{}" \;
+ rmdir "${ROOT}/usr/${TARGET}/usr/include" >& /dev/null
+ rmdir "${ROOT}/usr/${TARGET}/usr" >& /dev/null
+ rmdir "${ROOT}/usr/${TARGET}" >& /dev/null
+ fi
+ fi
+
+ #
+ # Make sure proper paths get updated
+ #
+ if [[ ${TARGET} == ${HOST} ]] ; then
+ DATAPATH=/usr/share/binutils-data/${TARGET}/${VER}
+ local e="${ROOT}"/etc/env.d/05binutils
+ local ee="${e}.tmp"
+ rm -f "${ee}"
+ [[ -d ${ROOT}/${DATAPATH}/man ]] && echo "MANPATH=${DATAPATH}/man" >> "${ee}"
+ [[ -d ${ROOT}/${DATAPATH}/info ]] && echo "INFOPATH=${DATAPATH}/info" >> "${ee}"
+ # hmm, `ld` has this in SEARCH_DIR(), but ld.so does not ...
+ if [[ -d ${ROOT}/etc/ld.so.conf.d ]] ; then
+ local l="${ROOT}"/etc/ld.so.conf.d/05binutils.conf
+ local ll="${l}.tmp"
+ echo "/usr/${TARGET}/lib" > "${ll}"
+ mv_if_diff "${ll}" "${l}"
+ else
+ echo "LDPATH=/usr/${TARGET}/lib" >> "${ee}"
+ fi
+ mv_if_diff "${ee}" "${e}"
+ fi
+
+ local c="${ENV_D}/config-${TARGET}"
+ local cc="${c}.tmp"
+ echo "CURRENT=${VER}" > "${cc}"
+ mv_if_diff "${cc}" "${c}"
+
+ eend 0
+
+ #
+ # Regen env.d if need/can be
+ #
+ if [[ ${ROOT} == "/" ]] && [[ ${TARGET} == ${HOST} ]] ; then
+ env-update
+ echo
+ ewarn "Please remember to run:"
+ echo
+ ewarn " # . /etc/profile"
+ echo
+ fi
+
+ return 0
+}
+
+uninstall_target() {
+ : ${TARGET:=${UARG}}
+
+ if [[ ${TARGET} == ${HOST} ]] ; then
+ die "refusing to uninstall native binutils"
+ fi
+
+ shopt -s nullglob
+ PROFILE=""
+
+ for PROFILE in "${ENV_D}"/${TARGET}-* ; do
+ ewarn "Removing all signs of ${PROFILE##*/}"
+ rm -f "${ENV_D}"/${PROFILE}
+ done
+ if [[ -z ${PROFILE} ]] && [[ ! -e ${ENV_D}/config-${TARGET} ]] ; then
+ die "no profiles exist for '${TARGET}'"
+ fi
+
+ rm -f "${ENV_D}"/config-${TARGET}
+
+ local x
+ for x in \
+ addr2line ar as c++filt elf2flt elfedit flthdr gprof \
+ ld ld.{bfd,gold,real} \
+ nm objcopy objdump ranlib readelf size strings strip
+ do
+ x=(
+ "${ROOT}"/usr/bin/${TARGET}-${x}
+ "${ROOT}"/usr/{${HOST}/,}${TARGET}/bin/${x}
+ "${ROOT}"/usr/libexec/gcc/${TARGET}/${x}
+ )
+ rm -f "${x[@]}"
+ done
+ for x in ansidecl.h bfd.h bfdlink.h dis-asm.h symcat.h ; do
+ rm -f "${ROOT}"/usr/{${HOST}/,}${TARGET}/{usr/,}include/${x}
+ done
+ for x in bfd iberty opcodes ; do
+ rm -f "${ROOT}"/usr/${HOST}/${TARGET}/lib/lib${x}{{-*,}.so,.a,.la}
+ done
+ # Delete broken symlinks
+ local destdir="${ROOT}/usr/${HOST}/${TARGET}"
+ rm -f "${destdir}"/lib/ldscripts
+ find -L "${destdir}"/lib -type l -exec rm {} +
+ rmdir \
+ "${destdir}"/{bin,include,lib,usr} \
+ "${destdir}" \
+ "${ROOT}"/var/db/pkg/cross-${TARGET} \
+ "${ROOT}"/usr/{${HOST}/,}${TARGET}/bin \
+ "${ROOT}"/usr/libexec/gcc/${TARGET} \
+ 2>/dev/null
+
+ rm -f "${ENV_D}"/${TARGET}-*
+}
+
+set_current_profile() {
+ if [[ ! -f ${ENV_D}/config-${TARGET} ]] ; then
+ eerror "${argv0}: unable to locate a profile for target: ${TARGET}"
+ return 1
+ fi
+
+ source "${ENV_D}/config-${TARGET}"
+
+ if [[ -z ${CURRENT} ]] ; then
+ eerror "${argv0}: no binutils profile is active!"
+ return 1
+ fi
+
+ echo "${TARGET}-${CURRENT}"
+
+ return 0
+}
+get_current_profile() { echo "${PROFILE}" ; }
+
+list_profiles() {
+ local x i target
+
+ if [[ ${ROOT} != / ]] ; then
+ echo "Using binutils-config info in ${ROOT}"
+ fi
+
+ set -- "${ENV_D}"/*
+ target=
+ i=1
+
+ for x ; do
+ # skip broken links and config files
+ [[ -f ${x} ]] || continue
+ [[ ${x} == */config-* ]] && continue
+
+ source "${x}"
+ if [[ ${target} != ${TARGET} ]] ; then
+ [[ -n ${target} ]] && echo
+ target=${TARGET}
+ fi
+
+ x=${x##*/}
+ if [[ -e ${ENV_D}/config-${TARGET} ]] ; then
+ source "${ENV_D}/config-${TARGET}"
+ if [[ ${VER} == ${CURRENT} ]] ; then
+ [[ ${TARGET} == ${HOST} ]] \
+ && x="${x} ${GOOD}*${NORMAL}" \
+ || x="${x} ${HILITE}*${NORMAL}"
+ fi
+ fi
+
+ # We would align the [...] field like so:
+ #printf ' [%*ss] %s\n' ${##} "${i}" "${x}"
+ # but this breaks simple scripting: `binutils -l | awk '{print $2}'`
+
+ # Or we could align the target col like so:
+ #printf ' [%s]%*s %s\n' "${i}" $(( ${##} - ${#i} )) "" "${x}"
+ # but i'm not sold that it looks better
+
+ # So keep it simple ... only makes a diff anyways for crazy people
+ # like me which have 100+ binutils packages installed ...
+ echo " [$i] ${x}"
+ ((++i))
+ done
+}
+
+switch_linker() {
+ local bpath ld=$1
+
+ case ${ld} in
+ ld.*) ;;
+ *) die "not supported: linker must start with 'ld.'" ;;
+ esac
+
+ setup_env || return 1
+ bpath="${ROOT}/${BINPATH}"
+
+ # does this binutils even support the requested linker ?
+ if [[ ! -e ${bpath}/${ld} ]] ; then
+ die "sorry, but ${PROFILE} doesn't support the ${ld} linker"
+ fi
+
+ # switch it up
+ ebegin "Setting default linker to ${ld} for ${PROFILE}"
+ atomic_ln ${ld} "${bpath}" ld
+ eend $?
+}
+
+set_HOST() {
+ # Set HOST to CHOST if it isn't already set
+ : ${HOST:=${CHOST:-$(portageq envvar CHOST)}}
+}
+
+ENV_D="${ROOT}etc/env.d/binutils"
+
+DEBUG="no"
+NEED_ACTION="yes"
+DOIT="switch_profile"
+PROFILE="current"
+HOST=""
+TARGET=""
+unset UARG
+
+select_action() {
+ if [[ ${NEED_ACTION} != "no" ]] ; then
+ NEED_ACTION="no"
+ DOIT=$1
+ else
+ die "one action at a time!"
+ fi
+}
+
+while [[ $# -gt 0 ]] ; do
+ x=$1
+ shift
+ case ${x} in
+ -c|--get-current-profile) select_action get_current_profile ;;
+ -l|--list|--list-profiles) select_action list_profiles ;;
+ -u|--uninstall) select_action uninstall_target ;;
+ --linker) select_action "switch_linker $1"; shift ;;
+ -d|--debug) DEBUG="yes" ;;
+ -h|--help) usage 0 ;;
+ -V|--version)
+ unset Header
+ cvsver="$Id$"
+ cvsver=${cvsver##*binutils-config-}
+ bver=${cvsver%%,v *}
+ cvsver=${cvsver#* }
+ echo "binutils-config-${bver} (r${cvsver%% *})"
+ exit 0
+ ;;
+ -*)
+ die "invalid switch! Try '--help'."
+ ;;
+ *)
+ if [[ ${UARG+set} == "set" ]] ; then
+ die "only one profile/target at a time please"
+ fi
+ NEED_ACTION="maybe"
+ UARG=${x}
+ ;;
+ esac
+done
+
+[[ ${NEED_ACTION} == "yes" ]] && usage 1
+[[ ${DEBUG} == "yes" ]] && set -x
+
+# All operations need to know the current HOST to figure out
+# what is a native target and what is a cross target
+set_HOST
+
+# All operations need to know the profile the user wants
+case ${DOIT} in
+switch_profile|switch_linker_*)
+ # decode user's profile choice
+ x=${UARG:-$(TARGET=${HOST} set_current_profile)}
+ PROFILE=""
+ if [[ -z $(echo ${x} | tr -d '[:digit:]') ]] ; then
+ # User gave us a # representing the profile
+ i=1
+ for y in "${ENV_D}"/* ; do
+ [[ ${y/config-} != ${y} ]] && continue
+
+ if [[ -f ${y} ]] && [[ ${x} -eq ${i} ]] ; then
+ PROFILE=${y##*/}
+ break
+ fi
+ ((++i))
+ done
+ fi
+
+ if [[ -z ${PROFILE} ]] ; then
+ # User gave us a full HOST-ver
+ x=${x##*/}
+ if [[ -f ${ENV_D}/${x} ]] ; then
+ # Valid HOST-ver yeah!
+ PROFILE=${x}
+ else
+ # Not a valid HOST-ver ...
+ if [[ ! -f ${ENV_D}/config-${x} ]] ; then
+ # Maybe they just gave us a ver ...
+ if [[ -f ${ENV_D}/${HOST}-${x} ]] ; then
+ x=${HOST}-${x}
+ else
+ die "could not locate '$x' in '${ENV_D}/'!"
+ fi
+ PROFILE=${x}
+ else
+ # Maybe they just gave us a target ... pick active profile
+ PROFILE=$(TARGET=${x} set_current_profile)
+ fi
+ fi
+ fi
+ ;;
+*)
+ # lookup current profile as the user gave us a target
+ PROFILE=$(TARGET=${UARG:-${HOST}} set_current_profile) || exit 1
+ ;;
+esac
+
+eval ${DOIT}
+
+# vim:ts=4
diff --git a/sys-devel/binutils-config/files/binutils-config.8 b/sys-devel/binutils-config/files/binutils-config.8
new file mode 100644
index 00000000000..0d8adb5a70b
--- /dev/null
+++ b/sys-devel/binutils-config/files/binutils-config.8
@@ -0,0 +1,77 @@
+.TH "BINUTILS-CONFIG" "8" "Jan 2005" "Gentoo" "Gentoo"
+.SH "NAME"
+binutils-config \- manage active versions of the binutils programs
+.SH "DESCRIPTION"
+The \fBbinutils-config\fR script allows you to switch between different
+versions of binutils when you have installed multiple copies (see
+USE=multislot). It also allows you to manage multiple cross-compiling
+targets simultaneously.
+
+Remember, you may have one version of binutils active per \fICTARGET\fR,
+and changing the version for one target has no bearing on any other. So
+changing an active cross-compiler will not break your native compiler
+(i.e. \fICHOST\fR).
+.SH "SYNOPSIS"
+\fBbinutils-config\fR [\fIcrufty options\fR] \fIPROFILE\fR
+
+\fBbinutils-config\fR \fB--get-current-profile\fR \fI[TARGET]\fR
+
+\fBbinutils-config\fR \fB--list-profiles\fR
+
+\fBbinutils-config\fR \fB--uninstall\fR \fITARGET\fR
+.SH "GENERIC OPTIONS"
+.TP
+\fBPROFILE\fR
+Change the system to use the specified binutils version. This may take the
+form of the list index number (the number shown on the left in the
+\fB\-\-list\-profiles\fR output), a full \fITARGET-VERSION\fR (useful when
+working with cross-compilers), just a \fITARGET\fR where the \fIVERSION\fR
+is picked from the active, or just a binutils \fIVERSION\fR where the
+\fITARGET\fR is assumed to be the native \fIHOST\fR value.
+.TP
+\fBTARGET\fR
+Similiar to \fBPROFILE\fR, but this is only the target and no version info
+(i.e. \fICTARGET\fR or \fICHOST\fR).
+.TP
+\fB\-c\fR, \fB\-\-get\-current\-profile\fR \fI[TARGET]\fR
+Display the active profile for \fITARGET\fR. If none is specified, the
+host system's \fITARGET\fR will be shown (i.e. \fICHOST\fR).
+.TP
+\fB\-l\fR, \fB\-\-list\-profiles\fR
+Show all the profiles that your system currently has installed and what
+versions are active. The active native version is noted with a bright green
+asterisk while the active cross-compiler versions are noted with a light blue
+asterisk.
+.TP
+\fB-u\fR, \fB\-\-uninstall\fR \fITARGET\fR
+This is really for internal use only. Used to remove all traces of the
+\fITARGET\fR binutils from your system.
+.SH "CRUFTY OPTIONS"
+.TP
+\fB\-\-gold\fR
+Change the default linker for the specified \fIPROFILE\fR to the [newer] gold
+linker. This only works if the binutils actually supports gold. Note that
+not all options supported by the bfd linker are supportd by the gold linker.
+.TP
+\fB\-\-bfd\fR
+Change the default linker for the specified \fIPROFILE\fR to the [older but
+stable] bfd linker. If unsure, stick to this one.
+.SH "REPORTING BUGS"
+Please report bugs via http://bugs.gentoo.org/
+.SH "SEE ALSO"
+.BR ar (1),
+.BR as (1),
+.BR ld (1),
+.BR nm (1),
+.BR objcopy (1),
+.BR ranlib (1),
+.BR readelf (1),
+.BR strings (1),
+.BR strip (1)
+.SH "FILES"
+.nf
+.BR /usr/bin/binutils-config
+.BR /etc/env.d/binutils/*
+.fi
+.SH "AUTHORS"
+Mike Frysinger <vapier@gentoo.org>
diff --git a/sys-devel/binutils-config/metadata.xml b/sys-devel/binutils-config/metadata.xml
new file mode 100644
index 00000000000..fb4199eb7af
--- /dev/null
+++ b/sys-devel/binutils-config/metadata.xml
@@ -0,0 +1,5 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
+<pkgmetadata>
+<herd>toolchain</herd>
+</pkgmetadata>